/* Feedback plugin for Operathon GHOST, v0.1.
 Created by nugarp/spazzy. Last Updated 9/26/22.
 This is an example of a file that is using MAMEHooker outputs
 from another program (in this case, TP/Output Blaster) in order
 to transform the GunMotor effects to rumble + recoil. */

const { HookPlugin } = require('./hookplugin')

// HookPlugins can leverage the STATE object in ticks:
// state["Property"] = { value, oldValue, changed }
// state.changed = boolean indicating ANY change since last poll

class OperationGhostObPlugin extends HookPlugin {
    constructor(info, players, nil) {
        console.log('opghost ob')
        super(info, players, ["1pRecoil", "2pRecoil"]); // register relevant outputs
    }
    
    hook () {
        console.log("opghost ob: hooked");
        this.players[0].setAutofireTimings(25,25); // 25 + 25 + 6 = 56ms // can't really get *too* much shorter than that (maybe 22+22+6=50 as in HOTD4)
        this.players[1].setAutofireTimings(25,25); // 25 + 25 + 6 = 56ms // can't really get *too* much shorter than that (maybe 22+22+6=50 as in HOTD4)
    }

    tick () {
        let guns = ["1pRecoil", "2pRecoil"];
        for (let i = 0; i < guns.length; i++) {
            if (this.state[guns[i]].changed && this.state[guns[i]].value) {
                this.players[i].fireRecoil(1);
                this.players[i].setRumbleEffect("GUN", 255, 100);
            }
        }
        super.tick();
    }

    unhook () {
        this.players[0].setAutofireTimings(45,45);
        this.players[1].setAutofireTimings(45,45);
        console.log("opghost ob: unhooked");
    }
}



exports.generate = (info, players, nil) => { return new OperationGhostObPlugin(info, players, nil); };