let memoryjs = require('memoryjs');

const processName = "supermodel.exe";
const processObject = memoryjs.openProcess(processName);

const address = 0x113F3256;

const matchingModules = memoryjs
  .getModules(processObject.th32ProcessID)
  .filter(mod => address >= mod.modBaseAddr && address <= (mod.modBaseAddr + mod.modBaseSize));

const matchingRegions = memoryjs
  .getRegions(processObject.handle)
  .filter(region => address >= region.BaseAddress && address <= (region.BaseAddress + region.RegionSize));

console.log('modules', matchingModules);
console.log('regions', matchingRegions);

const pattern = "39 00 00 48 A9 00 00 48";
memoryjs.findPattern(processObject.handle, 'supermodel.exe', pattern, memoryjs.NORMAL, 0, 0, (error, address) => {
  console.log(`error: ${error}, address: 0x${address.toString(16).toUpperCase()}`);
});
